from datetime import datetime
 
def process(transaction):
    incoming = transaction.getIncoming()
    meta_properties = read_meta_data(incoming)
    parent_dataset_id = meta_properties['storage_provider.parent.dataset.id']
    print("Demo dropbox parnet dataset: " + parent_dataset_id)
    data_set = transaction.createNewDataSet()
    transaction.moveFile(incoming.getAbsolutePath(), data_set)
    search_service = transaction.getSearchService()
    parent_experiment = find_parent_experiment(search_service, parent_dataset_id)
    data_set.setExperiment(parent_experiment)
    data_set.setParentDatasets([ parent_dataset_id ])
    
def read_meta_data(incoming):
    meta_data_file = incoming.getAbsolutePath() + "/metadata.properties"
    meta_content = read_lines_without_comment(meta_data_file)
    meta_properties = dict(line.strip().split('=') for line in meta_content)
    return meta_properties 

def find_parent_experiment(search_service, dataset_id):
    data_set = search_service.getDataSet(dataset_id)
    experiment = data_set.getExperiment()
    return experiment

def read_lines_without_comment(path):
    lines = []
    for line in open(path):
        if line.lstrip().startswith("#"):
            continue
        lines.append(line)
    return lines
    